//GDdoctor Pro by Niklas Roy // 3.11.2006  // sorry for awful code -- it was a quickhack


int[] sensor=new int[33];
int i;
int j;
int x;
int y;
int inByte;
int slider1=0;
int sl1x=270;
int slider2=100;
int sl2x=295;
int bary1;
int bary2;
int shiftcontr;
int mindif=255;
int maxdif;
int count;
int contrpos=-30;
int resetpos=210;
int invertpos=260;
int invertposx=00;
int kp,ki,kd,ks;
int secold;
String yesno;


int linepos,avbright,brightval,kc,steer,drive,odoprint,ool,calibrate;
float steerfl;
float multiplycontr=1;
float odo;

boolean drags1;
boolean drags2;
boolean invert=true,invert_old=true;
boolean mouse_over_invert;
boolean scroll=true;

import processing.serial.*;

Serial myPort;  // The serial port:

void setup() {
  // List all the available serial ports:
  println(Serial.list());
  myPort = new Serial(this, Serial.list()[0], 57600);
  PFont font;
  font = loadFont("Verdana-10.vlw"); 
  textFont(font, 10); 
  size (450,950);
  background (255);
}

void draw() {         
  noStroke();                         // clear display (where necessary)
  fill(240);                    
  rect (20,19,224,262);
  fill(255);
  rect (245,19,75,262);
  rect (330,0,140,950);
  
     inByte = myPort.read();     
  while (inByte!=0) {                   // sync data stream on 'nul'
    inByte = myPort.read();
  }
 
  
      //button (invert scan)
      stroke(0);
      if (mouseX>=331+invertposx && mouseX<=431+invertposx && mouseY>=20+invertpos && mouseY<=40+invertpos){fill(255,0,0); mouse_over_invert=true;} else {if (invert) {fill(50);} else {fill(255);} mouse_over_invert=false;} 
      if (mouse_over_invert && mousePressed) {invert=!invert_old;} else {invert_old=invert;}
      rect(331+invertposx,20+invertpos,100,20);
      if (invert) {fill(255);} else {fill(0);}
      text("invert scan",352+invertposx,34+invertpos);
  
  
      //button (reset min/max)
      stroke(0);
      if (mouseX>=331 && mouseX<=431 && mouseY>=45+resetpos && mouseY<=65+resetpos){fill(255,0,0);if (mousePressed) {mindif=255;maxdif=0;}} else {fill(255);} 
      rect(331,45+resetpos,100,20);
      fill(0);
      text("reset min./max.",337,59+resetpos);
      
      // slider1 (adjust contrast)
    pushMatrix();
    translate (sl1x-3,190);
    rotate(-HALF_PI);
    fill(0); text("display contrast", 0,0);
    popMatrix();
    stroke(0);
    line(sl1x,20,sl1x,245);
    if (mouseX>=sl1x-10 && mouseX<=sl1x+10 && mouseY>=slider1+20 && mouseY<=slider1+30 && drags2==false)
    {fill(255,0,0); if (mousePressed){drags1=true;}} // mouse over slider1
    else 
    {fill(255);}
    if (mousePressed==false) {drags1=false;}
    if (drags1) {slider1=constrain(mouseY-25,0,215); fill(255,0,0);}
    rect (sl1x-10,slider1+20,20,10); 
    
    multiplycontr=215-slider1;
    multiplycontr=multiplycontr/50+1;
    
        // slider2 (adjust shift)
    pushMatrix();
    translate (sl2x-3,190);
    rotate(-HALF_PI);
    fill(0); text("display brightness", 0,0);
    popMatrix();
    stroke(0);
    line(sl2x,20,sl2x,245);
    if (mouseX>=sl2x-10 && mouseX<=sl2x+10 && mouseY>=slider2+20 && mouseY<=slider2+30 && drags1==false)
    {fill(255,0,0);if (mousePressed){drags2=true;}} // mouse over slider2
    else 
    {fill(255);}
    if (mousePressed==false) {drags2=false;}
    if (drags2) {slider2=constrain(mouseY-25,0,215); fill(255,0,0);}
    rect (sl2x-10,slider2+20,20,10); 
    
    shiftcontr=slider2*4;
  
  stroke(0);                        //read bar values and draw bars (LDU)
  fill(255);
  for (i=0;i<32;i++){
    if (i==4 || i==12 || i==20 || i==28 ) {fill(220);}
    if (i==8 || i==16 || i==24) {fill(255);}
    while(myPort.available()==0){}
    sensor[i]=myPort.read();

    sensor[i]=constrain(int(sensor[i]*multiplycontr-shiftcontr),0,255);
    bary1=255-sensor[i]+20;
    bary2=sensor[i];
    rect (i*7+20,bary1,5,bary2);    
    }
    
    // draw scan
    if (secold!=second()) {noStroke(); fill(255); rect(303,282,17,12); fill(170); text(second(),303,290); stroke(200);line(10,280,320,280); secold=second();}
    for (i=0;i<32;i++){             
    if (invert) {stroke (255-sensor[i]);} else {stroke (sensor[i]);}   
    line (i*7+20,280,i*7+25,280);
    if (ool==11) {stroke(255,0,0);} //out of line
    else {stroke(255);}   
    line(10,280,18,280);
    }  
    while(myPort.available()==0){}  
    linepos = myPort.read();         //read lineposition
    linepos=constrain(linepos,0,31);
    stroke(0,200,0);
    linepos=32-linepos;
    line(linepos*7+23,19,linepos*7+23,280);
    line(linepos*7+24,19,linepos*7+24,280);
    
    while(myPort.available()==0){}
    avbright = myPort.read();       //read average brightness
    while(myPort.available()==0){}
    brightval = myPort.read();      //read value of brightest sensor
    while(myPort.available()==0){}
    kc = myPort.read();             //read value of contrast poti
    while(myPort.available()==0){}   
    steer = myPort.read();          //read steering value
    while(myPort.available()==0){}  
    drive = myPort.read();          //read driving value
    while(myPort.available()==0){}   
    odoprint = myPort.read();       //read odometer value
    while(myPort.available()==0){}
    ool = myPort.read();            //read out of line detection
    while(myPort.available()==0){}
    calibrate = myPort.read();      //read calibrate
    while(myPort.available()==0){}
    kp=myPort.read();               //read p-poti
    while(myPort.available()==0){}
    ki=myPort.read();              //read i-poti
    while(myPort.available()==0){}
    kd=myPort.read();              //read d-poti
    while(myPort.available()==0){}
    ks=myPort.read();              //read s-poti
    
    myPort.clear();                  // delete serial buffer
    
    steerfl=steer-139;              // draw steering log + blue line
    steerfl=steerfl*5.894+20;
    stroke(100,100,255);   
    line(steerfl-1,19,steerfl-1,280);
    line(steerfl,19,steerfl,280);
    
    stroke(128);                    //draw driving log (red)
    point(247,280);
    point(270,280);
    point(295,280);
    stroke(255,0,0);
    line((drive-158)*3+249,280,(drive-158)*3+251,280);
    
    stroke(255,0,255);              //draw odolog (magenta)
    odo=255-odoprint;
    odo=odo/5.3;
    line(249+odo,280,249+odo,280); 
    
    if (brightval-avbright>maxdif) {maxdif=brightval-avbright;}  // calculate and draw contrast adjustment helpers
    if (brightval-avbright<mindif) {mindif=brightval-avbright;}
    stroke(220,220,0);
    fill(220,220,0);
    line(339,275-avbright-mindif+contrpos,360,275-avbright-mindif+contrpos);
    text ("min.",362,280-avbright-mindif+contrpos);
    stroke(200);
    fill (200);
    line(339,275-avbright-maxdif+contrpos,360,275-avbright-maxdif+contrpos);   
    text ("max.",362,276-avbright-maxdif+contrpos);
    
    stroke(0);                      //draw contrast,avbright,brightval - bars
    fill (200);
    rect (331,275+contrpos,5,-brightval);
    fill (50);
    rect (338,275+contrpos,5,-avbright);
    fill (255,255,0);
    rect (338,275-avbright+contrpos,5,-kc);
  

    fill(50); text("average", 350,240+contrpos);
    text ("brightness",350,252+contrpos);
    fill(220,220,0); text("contrast poti",350,228+contrpos);
    fill(200); text("detected line", 350,264+contrpos);
    text("brightness", 350,276+contrpos);
 
    
    
    fill(0,200,0); text("detected line",25,35);          //texts
    fill(100,100,255); text("steering voltage",25,45);
    fill (255,0,0); text("drivelog",250,276);
    fill (255,0,255); text("odolog",253,264);
    
    fill(0);
    text("linepos: "+linepos, 331,460);
    text("avbright: "+avbright, 331,51);
    text("brightval: "+brightval, 331,63);
    fill(200,200,0);
    text("contrast: "+kc, 331,39);
    fill(0);
    text("steer: "+steer, 331,480);
    text("drive: "+drive, 331,500);
    if (ool==10) {yesno="yes"; fill(0,200,0);} else {yesno="no"; fill(255,0,0);}
    text("online: "+yesno, 331,27);
    fill(0); 
    text("p-factor: "+kp,331,350);
    ki=ki-1;
    text("i-factor: "+ki,331,370);
    text("d-factor: "+kd,331,390);
    text("speed-factor: "+ks,331,410);
    
    if (drive!=157 && scroll){
    loadPixels();                    //shift scan down
    for (y=930;y>=281;y--){
      for (x=10;x<=319;x++){
        pixels[y*width+x]=pixels[y*width+x-width];
        }
    }
    updatePixels(); 
    }
    	
}
